Bug 30425

Summary: Making Icon Themes is Far too Difficult
Product: LibreOffice Reporter: Andrew <rugby471>
Component: LibreofficeAssignee: Jan Holesovsky <kendy>
Status: NEW --- QA Contact:
Severity: enhancement    
Priority: medium CC: dent.ace, libreoffice
Version: unspecified   
Hardware: Other   
OS: All   
Whiteboard: EasyHack DifficultyBeginner SkillScript TopicUi
i915 platform: i915 features:
Bug Depends on: 63962    
Bug Blocks:    

Description Andrew 2010-09-28 09:03:59 UTC
The way that LibreOffice packages its icon themes if far too complex and difficult and therefore stifles creativity when it comes to creating new icon themes.

Icon are given cryptic names such as envvl_l.png in cryptic directories such as sw/res and therefore an artist has to spend more time working out where an icon should go, rather than creating a theme.

I propose that a readable naming scheme should be put in place that fixes this, maybe something similar to what GTK uses at the moment?

As well as this, only icon should be distributed in a theme package, not unnecessary files such as go-oo-team.png :) These should be packaged with LibreOffice, not in the icon theme package.

Thanks :)
Comment 1 Katarina Behrens 2010-09-29 02:15:45 UTC
This sounds like a new feature request. Assigned to Kendy to decide who's going to take care
Comment 2 Jan Holesovsky 2010-10-29 17:26:02 UTC
Andrew: Do I understand it correctly that your are an artist actually interested in creating, or improving an icon theme?  Would be great to meet you on our IRC - irc.freenode.net, channel #libreoffice.  Poke me there - I am 'kendy', I think it would be good to talk about this a bit.

I am moving the points you raised to Easy Hacks:

http://wiki.documentfoundation.org/Development/Easy_Hacks#Give_the_icons_reasonable_names
Comment 3 Bob Harvey 2011-01-29 03:53:39 UTC
Is this a good time to mention http://www.openoffice.org/issues/show_bug.cgi?id=18829 ? , which still has 107 votes and which dates back to 2003.
Comment 4 Björn Michaelsen 2011-07-21 07:41:40 UTC
==== Give the icons reasonable names ====

'''Background:''' [https://bugs.freedesktop.org/show_bug.cgi?id=30425 fdo#30425#]

Icon are given cryptic names such as envvl_l.png in cryptic directories such as sw/res and therefore an artist has to spend more time working out where an icon should go, rather than creating a theme. The proposal is that a readable naming scheme should be put in place. Ideally, if the names of the main icons are the same as eg. in Gnome. The process of documentation and planning has begun here: [[Development/Icon Themes|Icon Themes]]. Any coding effort can be supported by ace_dent.

'''Skills: '''build, trivial C++, searching in opengrok
Comment 5 Jan Holesovsky 2012-10-10 14:44:12 UTC
To be able to do this, you need to first find the icon in .src file.  Eg. for icon-themes/galaxy/sw/res/envvl_l.png, it must be in the 'sw' subdir (galaxy is name of the theme).  So do:

git grep envvl_l sw

it will tell you

sw/source/ui/envelp/envprt.src:    File = "envvl_l.bmp" ;

Now you can open that .src file, change the name of the icon there, and then

git mv icon-themes/galaxy/sw/res/envvl_l.png icon-themes/galaxy/sw/res/newname.png

NOTE: You have to do the 'git mv' for every icon theme!

NOTE: For icons that are named like blah0123.png, it makes no sense to try to rename them, they are part of ImageLists, the 'blah' is a prefix there, and the number has to stay.  You can get them a better prefix, but that is all at the moment.
Comment 6 Björn Michaelsen 2013-10-04 18:47:23 UTC
adding LibreOffice developer list as CC to unresolved EasyHacks for better visibility.

see e.g. http://nabble.documentfoundation.org/minutes-of-ESC-call-td4076214.html for details
Comment 7 Andrew 2014-02-06 21:09:29 UTC
...
Comment 8 Andrew 2014-02-15 10:05:48 UTC
Proposed workflow, taking advantage of links.txt to remap icon references at runtime:

After creating a canonical icon, and searching source for references to the duplicate .png icon file…

1. No reference found in source:
- ICON 	- Delete redundant png file.
- SOURCE - No action required.
- LINKS - aLink - Remove any old links. Add link to canonical icon to be safe. Tag: '#unreferenced' for future removal.
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'No source reference found for icon. Complete link removal after further investigations'.

2. Referenced only by full path:
- ICON 	- Delete redundant png file.
- SOURCE - Modify source reference, so that the full path points to new canonical icon.
- LINKS - aLink - Remove any old links (every theme should have the canonical icon, or fallback to Galaxy icon thru packimages build script).
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - None required.

3. Referenced by .uno:Controller:
- ICON 	- Delete redundant png file.
- SOURCE - Do not change any .uno:Command function names or code. Safe to modify other source references with the full path to the canonical icon. 
- LINKS - aLink - Remove any old links. Add link to canonical icon. Tag: '#command123', where '123' is the number of uno references found (for sorting).
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'Referenced by .uno:Command. Icon name maintained through links.txt'.

4. Referenced by ImageList index:
- ICON 	- Delete redundant png file.
- SOURCE - Do not change any index numbers, reference or code. Safe to modify other source references with the full path to the canonical icon. 
- LINKS - aLink - Remove any old links. Add link to canonical icon. Tag: '#imagelist', for future fixing / removal.
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'Referenced by ImageList index. Icon name maintained through links.txt'.

It is unlikely an icon will fall under both types 3 & 4.

Also... 
- Fix Copyright notices to include new Canonical name after original, i.e. 'X.png' becomes 'X.png (> Y.png)'. CopyrightsHuman CopyrightsTango CopyrightsOxygen.
- Change any references in helpcontent2 (Modify source reference, so that the full path points to new canonical icon.)
- Fix filenames of SVG files and inside(?) (e.g 'select.svg' inside 'Select.SVG' ?).
- Other references within svg files used to build icon sets.

Push to Gerrit:
1) Main changes to LibO source.
2) Updates to helpcontent2
Pull request on Github:
3) SVG (& links.txt?) changes to Sifr theme
4) SVG & links.txt changes to Tango-experimental theme
Comment 9 Commit Notification 2014-07-27 03:54:40 UTC
Martin Owens committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=70599252873c3dbe03e36083ad093aedfdb8b923

fdo#30425 - button should be print, not print preview



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2014-07-30 18:43:20 UTC
Martin Owens committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=995fd28f88a5122d4f649f7710501bcd752cf6b5&h=libreoffice-4-3

fdo#30425 - button should be print, not print preview


It will be available in LibreOffice 4.3.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Adolfo Jayme 2014-07-30 23:56:19 UTC
The above patches are unrelated to this bug; it seems Martin got the bug number wrong. Removing “target” tags from whiteboard.
Comment 12 QA Administrators 2014-10-23 17:31:44 UTC
Please read this message in its entirety before responding.

Your bug was confirmed at least 1 year ago and has not had any activity on it for over a year. Your bug is still set to NEW which means that it is open and confirmed. It would be nice to have the bug confirmed on a newer version than the version reported in the original report to know that the bug is still present -- sometimes a bug is inadvertently fixed over time and just never closed.

If you have time please do the following:
1) Test to see if the bug is still present on a currently supported version of LibreOffice (preferably 4.2 or newer).
2) If it is present please leave a comment telling us what version of LibreOffice and your operating system.
3) If it is NOT present please set the bug to RESOLVED-WORKSFORME and leave a short comment telling us your version and Operating System

Please DO NOT
1) Update the version field
2) Reply via email (please reply directly on the bug tracker)
3) Set the bug to RESOLVED - FIXED (this status has a particular meaning that is not appropriate in this case)

+ + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + 
LibreOffice is powered by a team of volunteers, every bug is confirmed (triaged) by human beings who mostly give their time for free. We invite you to join our triaging by checking out this link:
https://wiki.documentfoundation.org/QA/BugTriage

There are also other ways to get involved including with marketing, UX, documentation, and of course developing -  http://www.libreoffice.org/get-help/mailing-lists/. 

Lastly, good bug reports help tremendously in making the process go smoother, please always provide reproducible steps (even if it seems easy) and attach any and all relevant material